//
// copyright (c) 2014 by 1801BM1@gmail.com
//______________________________________________________________________________
//
//`timescale 1ns / 1ns
#include "vm80a.hpp"


CVM80A::CVM80A()
{
}

void CVM80A::cycle(void)
{
	clk = pin_clk;
	f1 = pin_f1;
	f2 = pin_f2;

	posedgeclkn = pin_clk;
	posedgeclk = posedgeclkn && !posedgeold;
	posedgeold = posedgeclkn;

	abufena ? PinBUSA->drivebusvalue(Time, (DWORD)a) : PinBUSA->drivetristate(Time);//16'hZZZZ;
	db_ena ? PinBUSD->drivebusvalue(Time, (DWORD)db) : PinBUSD->drivetristate(Time);//8'hZZ;
	pin_din = (uint8_t)PinBUSD->getbusvalue();

	if(posedgeclk)
	{
//		f1_core = pin_f1;
//		f2_core = pin_f2;
	}

	//_____________________________________________________________________________
	//
	PinBUSA->drivebusvalue(Time, a);
	//pin_aena = abufena;
	//pin_dout = db;
	//pin_dena = db_ena;

	dbin_ext = dbinf2;
	d = ((!reset && !alu_zrd &&
		( dbin_ext && gb(di,7)
		|| mxrl && gb(mxo,7)
		|| mxrh && gb(mxo,15)
		|| t1f1 && sy_memr
		|| alu_xrd && gb(xr,7)
		|| alu_ard && gb(acc,7)
		|| alu_frd && psw_s
		|| alu_srd && gb(s,7)))<<7)||

		((!reset && !alu_zrd &&
		( dbin_ext && di,6)
		|| mxrl && gb(mxo,6)
		|| mxrh && gb(mxo,14)
		|| t1f1 && sy_inp
		|| alu_xrd && gb(xr,6)
		|| alu_ard && gb(acc,6)
		|| alu_frd && psw_z
		|| alu_srd && gb(s,6))<<6)||

		((!reset && !alu_zrd &&
		( dbin_ext && gb(di,5)
		|| mxrl && gb(mxo,5)
		|| mxrh && gb(mxo,13)
		|| t1f1 && sy_m1
		|| alu_xrd && gb(xr,5)
		|| alu_ard && gb(acc,5)
		|| alu_srd && gb(s,5)))<<5)||

		((!reset && !alu_zrd &&
		( dbin_ext && gb(di,4)
		|| mxrl && gb(mxo,4)
		|| mxrh && gb(mxo,12)
		|| t1f1 && sy_out
		|| alu_xrd && gb(xr,4)
		|| alu_ard && gb(acc,4)
		|| alu_frd && psw_ac
		|| alu_srd && gb(s,4)))<<4)||

		((!reset && !alu_zrd &&
		( dbin_ext && gb(di,3)
		|| mxrl && gb(mxo,3)
		|| mxrh && gb(mxo,11)
		|| t1f1 && sy_hlta
		|| alu_xrd && gb(xr,3)
		|| alu_ard && gb(acc,3)
		|| alu_srd && gb(s,3)))<<3)||

		((!reset && !alu_zrd &&
		( dbin_ext && gb(di,2)
		|| mxrl && gb(mxo,2)
		|| mxrh && gb(mxo,10)
		|| t1f1 && sy_stack
		|| alu_xrd && gb(xr,2)
		|| alu_ard && gb(acc,2)
		|| alu_frd && psw_p
		|| alu_srd && gb(s,2)))<<2)||

		((!reset && !alu_zrd &&
		( dbin_ext && gb(di,1)
		|| mxrl && gb(mxo,1)
		|| mxrh && gb(mxo,9)
		|| t1f1 && sy_wo_n
		|| alu_xrd && gb(xr,1)
		|| alu_ard && gb(acc,1)
		|| alu_frd
		|| alu_srd && gb(s,1)))<<1)||

		(!reset && !alu_zrd &&
		( dbin_ext && di,0)
		|| mxrl && gb(mxo,0)
		|| mxrh && gb(mxo,8)
		|| t1f1 && sy_inta
		|| alu_xrd && gb(xr,0)
		|| alu_ard && gb(acc,0)
		|| alu_frd && psw_c
		|| alu_srd && gb(s,0));

	if(posedgeclk)
	{
		if (f2 && db_stb) db = d;
		if (f2) abufena = (!twt2 || !thalt) && !hlda_pin;
		if (f1) db_stb = t1 || (!sy_wo_n && t2);
		if (f1) t851 = t1 || (!sy_wo_n && (t2 || tw || t3));
		if (f2) db_ena = !reset && t851;
	}

	//______________________________________________________________________________
	//
	// reset input buffer
	//
	if(posedgeclk)
	{
		if (f1) t404 = pin_reset;
		if (f2) reset = t404;
	}

	//______________________________________________________________________________
	//
	// hold input buffer
	//
	//pin_hlda = 
	hlda_pin = ishigh(PinHLDA->istate());
	hlda = hold && (t773 || (t3 && sy_wo_n) || (!m1 && sy_hlta) || t735);
	h889 = t2f1 || twf1; 

	if(posedgeclk)
	{
		if (f1) t712 = !sy_wo_n && t3;
		if (f2) t735 = t712;
		if (!f2) t382 = pin_hold;
		if (f2) t383 = ((!t382 && hold) || t383); // ext} the front detector pulse for entire F2 duration
		if (!f2) t383 = 0; 
		if (f2) t773 = hlda_pin;
		if (f1) PinHLDA->drivebool(Time, hlda);//hlda_pin = hlda;
	}

	if(posedgeclk)
	{
		if (reset)
			hold = 0;
		else
			if (f2)
			{
				if (t382)
				{
					if (!sy_inta && h889) hold = 1;
				}
				else
					hold = 0;
			}
	}

	//______________________________________________________________________________
	//
	//pin_dbin = 
	PinDBIN->drivebool(Time, dbin_pin);
	//pin_wr_n = 
	PinWR->drivebool(Time, wr_n);
	//pin_sync = 
	PinSYNC->drivebool(Time, sync);

	if(posedgeclk)
	{
		dbinf2 = (f2 || dbin_pin) && ((t1124 && (m1f1 || !sy_hlta)) || dbinf2);

		if (dbin_pin) di = pin_din;
		if (f2) dbin_pin = t1124 && (m1f1 || !sy_hlta);
		if (f2) sync = !ready_int && t1011;
		if (f1) t1011 = t1 && !reset;
		if (f1) t1124 = (t2 || tw) && sy_wo_n;
		if (f1) wr_n = !(t3 || tw) || ready_int || sy_wo_n;
	}

	//______________________________________________________________________________
	//
	// ready pin and internal circuits
	//
	ready_int = (m4 || m5) && id_dad;
	ready = ready_int || ishigh(PinRDY->istate());//pin_ready;
	//pin_wait = 
	PinWAIT->drivebool(Time, twf1);

	//______________________________________________________________________________
	//
	// BOOLister unit - 6 16-bit BOOListers
	//
	// r0 - pc
	// r1 - hl, de
	// r2 - de, hl
	// r3 - bc
	// r4 - sp
	// r5 - wz
	//
	t1467 = tree1 || (id04 && t4f1 && !id_xthl);
	t1519 = tree2 || (id00 && t4f1 && !id_xthl);
	mxi = inc16 ? (a++)// + 16'h0001)
		: dec16 ? (a--)// - 16'h0001)
		: a;

	inc16 = iad16 && !dec16;
	dec16 = iad16 && id05 && (t4f1 || t5f1 || m4f1 || m5f1);
	iad16 = !(id00 && (t4f1 || t5f1)) && (!minta || m5 || t3144);

	mxw16 = t3403;
	mxwadr = t3363 || (t4f1 && !id_dad && !id_hlt);
	t1513 = (t4f1 && id07) || t3335;
	t1514 = (t4f1 && id08) || t3361;

	mxrh = t2998 || (id08 && t4f1 && !i03);
	mxrl = t3047 || (id08 && t4f1 && i03);
	mxwh = t2817 || (t2806 && !i03);
	mxwl = t2819 || (t2806 && i03);

	mxr = tree0 |
		((xchg_dh && (((t1513 || t1514) && (!i14 && i25)) || t1519)
		|| !xchg_dh && (t1513 || t1514) && (i14 && !i25))<<1)|
		((xchg_dh && (t1513 || t1514) && (i14 && !i25)
		|| !xchg_dh && (((t1513 || t1514) && (!i14 && i25)) || t1519))<<2)|
		(((t1513 || t1514) && (!i14 && !i25))<<3)|
		((t1467 || (t1513 && i14 && i25))<<4);
	((!(t1467 || t1513 || t1514 || t1519 || tree0))<<5);

	if(posedgeclk)
	{
		if (f1) t3144 = t4 || t5 || (m4 && !id02);
		xchg_tt = id_xchg && t2;
		xchg_dh = !reset && ((xchg_tt && !(id_xchg && t2)) ? !xchg_dh : xchg_dh);
	}

	switch (mxr)
	{
	case 0x20: mxo = r16_pc;
		break;
	case 0x10: mxo = r16_hl;
		break;
	case 0x08: mxo = r16_de;
		break;
	case 0x04: mxo = r16_bc;
		break;
	case 0x02: mxo = r16_sp;
		break;
	case 0x01: mxo = r16_wz;
		break;
	default: mxo = 0;
		break;
	}

	if(posedgeclk)
		if (f2)
		{
			if (mxwadr) a = mxo;
			if (mxw16)
			{
				if (gb(mxr,0)) r16_pc = mxi;
				if (gb(mxr,1)) r16_hl = mxi;
				if (gb(mxr,2)) r16_de = mxi;
				if (gb(mxr,3)) r16_bc = mxi;
				if (gb(mxr,4)) r16_sp = mxi;
				if (gb(mxr,5)) r16_wz = mxi;
			}
			else
			{
				if (mxwl)
				{
					if (gb(mxr,0)) {r16_pc &= 0xFF00; r16_pc |= d;}
					if (gb(mxr,1)) {r16_hl &= 0xFF00; r16_hl |= d;}
					if (gb(mxr,2)) {r16_de &= 0xFF00; r16_de |= d;}
					if (gb(mxr,3)) {r16_bc &= 0xFF00; r16_bc |= d;}
					if (gb(mxr,4)) {r16_sp &= 0xFF00; r16_sp |= d;}
					if (gb(mxr,5)) {r16_wz &= 0xFF00; r16_wz |= d;}
				}
				if (mxwh)
				{
					if (gb(mxr,0)) {r16_pc &= 0x00FF; r16_pc |= (d<<8);}
					if (gb(mxr,1)) {r16_hl &= 0x00FF; r16_hl |= (d<<8);}
					if (gb(mxr,2)) {r16_de &= 0x00FF; r16_de |= (d<<8);}
					if (gb(mxr,3)) {r16_bc &= 0x00FF; r16_bc |= (d<<8);}
					if (gb(mxr,4)) {r16_sp &= 0x00FF; r16_sp |= (d<<8);}
					if (gb(mxr,5)) {r16_wz &= 0x00FF; r16_wz |= (d<<8);}
				}
			}
		}

		//______________________________________________________________________________
		//
		// processor state
		//
		sy_hlta = id_hlt;
		sy_m1 = m1;
		sy_inp = m5 && id_in;
		sy_out = m5 && id_out;
		sy_inta = inta;
		sy_memr = sy_wo_n && !sy_inp && !minta;
		sy_wo_n = m1 || m2 || m3 || (((m4 && !id86) || (m5 && !id85)) && !ready_int);

		if(posedgeclk)
		{
			if (f1)
			{
				sy_stack = (t1 && t1460)
					|| (t3 && m3 && id_cxx && !jmptake)
					|| (t5 && m1 && id_rxx && !jmptake);
			}
		}
		//______________________________________________________________________________
		//
		// ticks state machine
		//
		twt2 = (t2f1 || twf1) && !start;
		thalt = !m1 && sy_hlta; 

		if(posedgeclk)
		{
			if (f1)
			{
				t1f1 = t1 && !reset; // ensure the reliable start after reset
				t2f1 = t2;
				twf1 = tw;
				t3f1 = t3;
				t4f1 = t4;
				t5f1 = t5;
			}
			if (f2)
			{
				t1 = start;
				t2 = !start && t1f1;
				tw = !start && (t2f1 || twf1) && (!ready || thalt);
				t3 = !start && (t2f1 || twf1) && ready && !thalt;
				t4 = !start && t3f1 && ms0 && !ms1;
				t5 = !start && t4f1 && ms0 && !ms1;
			}
		}

		//______________________________________________________________________________
		//
		m836 = m1f1 && id82;
		m839 = !t976 || !sy_hlta;
		m871 = t789 || id81; 

		start = !m839 
			|| t953
			|| (eom && !(hold && t887))
			|| (f2 && ((!t382 && hold) || t383) && !(twf1 || t3f1 || t4f1 || t5f1));

		ms0 = !reset && m839 && !(sy_stack && !t1f1) && !(eom && !m836);
		ms1 = !reset && m839 && !(sy_stack && !t1f1) && !(m871 && !m836) && eom;

		if(posedgeclk)
		{
			if (f1)
			{
				t789 = (id84 && m3) || (id83 && !id_mvim && m4) || m5;
				t887 = hold;
				t953 = reset;
				t976 = t980 && m4;
				eom = t5 
					|| t4 && m1 && id80
					|| t3 && m2
					|| t3 && m3
					|| t3 && m4
					|| t3 && m5 && !id_xthl;
			}
			if (f2)
			{
				t980 = sy_inta; 
			}
		}

		//______________________________________________________________________________
		//
		// processor cycles state machine
		//
		if(posedgeclk)
		{
			if (f1)
			{
				m1f1 = m1;
				m2f1 = m2;
				m3f1 = m3;
				m4f1 = m4;
				m5f1 = m5;
			}
			if (f2)
			{
				m1 = (!ms0 && !ms1) || (!ms1 && m1f1);
				m2 = (!ms0 || !ms1) && ((ms0 && m2f1) || (ms1 && m1f1));
				m3 = (ms0 && m3f1) || (ms1 && m2f1);
				m4 = (ms0 && m4f1) || (ms1 && m3f1) || (ms0 && ms1);
				m5 = (ms0 && m5f1) || (ms1 && m4f1);
			}
		}

		//______________________________________________________________________________
		//
		// interrupt logic
		//
		irq = intr && inte && !reset && !hold;
		//pin_inte = 
		PinINTE->drivebool(Time, inte);

		if(posedgeclk)
		{
			if (f2) intr = ishigh(PinINT->istate());//pin_int;
			if (f2) mstart = !ms0 && !ms1;
			if (sy_inta) minta = 1;
			if (f1 && t1 && m1) minta = 0;
		}

		if(posedgeclk||reset)
		{
			if (reset)
			{
				inta = 0;
				inte = 0;
			}
			else
			{
				if (f1) 
				{
					if (irq && ((tw && sy_hlta) || (mstart && !id_eidi))) inta = 1;
					if (!intr || id_eidi || (t5 && id_rst)) inta = 0;
				}
				if (f2)
				{
					if (t1f1 && id_eidi) inte = gb(i,3);
					if (t1f1 && sy_inta) inte = 0;
				}
			}
		}
		//______________________________________________________________________________
		//
		// instruction BOOLister and decoder
		//

imx = !(id_op || (id_mov && t4));

if(imx)
		{
			(i&(7<<3))==(7<<3)?acc_sel=TRUE:acc_sel=FALSE;
		}
		else
		{
			(i&7)==7?acc_sel=TRUE:acc_sel=FALSE;
		}

jmpflag = (psw_c && i14 && !i25) // Intel original: d[0] instead of psw_c
|| (psw_p && !i14 && i25) // Intel original: d[2] instead of psw_p
|| (psw_z && !i14 && !i25) // Intel original: d[6] instead of psw_z
|| (psw_s && i14 && i25); // Intel original: d[7] instead of psw_s

if(posedgeclk)
{
	//
	// Simplify the D-bus multiplexer and feed the I-BOOLister by input pins directly
	//
	if (!f2 && (reset || (m1 && t3))) i = pin_din;
	if (f1)
	{
		i25 = imx ? ((i&(1<<5))!=0?1:0):((i&(1<<2))!=0?1:0);//i[5] : i[2];
		i14 = imx ? ((i&(1<<4))!=0?1:0):((i&(1<<1))!=0?1:0);//i[4] : i[1];
		i03 = imx ? ((i&(1<<3))!=0?1:0):((i&(1<<0))!=0?1:0);//i[3] : i[0];
	}
}

bgoto = id_rst || id_jmp || id_call || (jmptake && (id_cxx || id_jxx));
t1460 = (t1 && ( (m2 && id00)
		 || (m3 && id00)
		 || (m4 && (id01 || id04))
		 || (m5 && (id01 || id04)))
		 || t2 && ( (m2 && id00)
		 || (m4 && id01)
		 || (m5 && id01))
		 || t3 && ( (m4 && (id04 || id_sphl)))
		 || t5 && ( (m1 && (id04 || id_sphl)))) && !(!jmptake && id_cxx && t5);

if(posedgeclk)
{
	if (f2 && t4f1)
	{
		jmptake = i03 ? jmpflag : !jmpflag;
	}
	if (f1)
	{
		tree0 = t1 && ( (m1 && !bgoto) 
			|| (m2 && !id_xthl)
			|| (m3 && !id_xthl)
			|| (m4 && id02))
			|| t2 && ( m1
			|| (m2 && !id_xthl)
			|| (m3 && !id_xthl)
			|| (m4 && (id02 || id_rst || id_cxx || id_call))
			|| (m5 && (id_rst || id_cxx || id_call)))
			|| t3 && ( (m4 && (id_ret || id_rxx))
			|| (m5 && (id_ret || id_rxx)))
			|| t5 && id_pchl;

		tree1 = t1460;

		tree2 = t1 && ( (m4 && (id_mov || id_idr || id_op))
			|| (m5 && id08))
			|| t2 && ( (m4 && (id_shld || id00 || id_dad))
			|| (m5 && (id_shld || id00 || id_dad)))
			|| t3 && ( (m4 && (id_lhld || id_dad))
			|| (m5 && (id_lhld || id_dad)))
			|| t5 && m5;

		t2806 = id08 && ((t3 && m4) || (t5 && m1)); 
		t2817 = reset || (t3 && (m1 || m3 || (m4 && id_io) || (m5 && id06)));
		t2819 = reset || (t3 && (m2 || (m4 && id06) || (m5 && id_rst)));

		t3047 = m4 && (t1 || t2) && id_dad
			|| t2 && ((m4 && id_shld) || (m5 && id03));

		t2998 = (t1 || t2) && m5 && id_dad
			|| t2 && ((m5 && id_shld) || (m4 && id03));

		t3403 = t2 && ( (m1 || m2)
			|| (m3 && !id_xthl)
			|| ((m4 || m5) && !id_dad && !id09))
			|| t3 && m4 && id09
			|| t5 && (m5 || (m1 && !id08));

		t3363 = t1 && (m1 || m2 || m3 || ((m4 || m5) && !id_hlt && !id_dad));
		t3335 = id07 && ((t1 && (m4 || m5)) || (t3 && (m2 || m3)) || t5);

		t3361 = t1 && m4 && id_lsax
			|| t2 && id10 && !sy_wo_n
			|| t3 && id10 && sy_wo_n && (m4 || m5)
			|| t5 && id08 && m1;
	}
}

		id_nop = cmp(i, 0, 0x38);//8'b00xxx000, 8'b00111000);
		id_lxi = cmp(i, 1, 0x30);//8'b00xx0001, 8'b00110000);
		id_lsax = cmp(i, 2, 0x18);//8'b000xx010, 8'b00011000);
		id_inx = cmp(i, 3, 0x30);//8'b00xx0011, 8'b00110000);
		id_inr = cmp(i, 4, 0x38);//8'b00xxx100, 8'b00111000);
		id_dcr = cmp(i, 5, 0x38);//8'b00xxx101, 8'b00111000);
		id_idr = cmp(i, 4, 0x39);//8'b00xxx10x, 8'b00111001);
		id_mvi = cmp(i, 6, 0x38);//8'b00xxx110, 8'b00111000);
		id_dad = cmp(i, 9, 0x30);//8'b00xx1001, 8'b00110000);
		id_dcx = cmp(i, 0x0A, 0x30);//8'b00xx1011, 8'b00110000);
		id_opa = cmp(i, 7, 0x38);//8'b00xxx111, 8'b00111000);
		id_idm = cmp(i, 0x34, 0x01);//8'b0011010x, 8'b00000001);
		id_stlda = cmp(i, 0x32, 0x08);//8'b0011x010, 8'b00001000);
		id_mvim = cmp(i, 0x36, 0x00);//8'b00110110, 8'b00000000);
		id_shld = cmp(i, 0x22, 0x00);//8'b00100010, 8'b00000000);
		id_lhld = cmp(i, 0x2A, 0x00);//8'b00101010, 8'b00000000);
		id_mvmr = cmp(i, 0x70, 0x07);//8'b01110xxx, 8'b00000111) & ~id_hlt;
		id_mvrm = cmp(i, 0x46, 0x38);//8'b01xxx110, 8'b00111000) & ~id_hlt;
		id_hlt = cmp(i, 0x76, 0x00);//8'b01110110, 8'b00000000);
		id_mov = cmp(i, 0x40, 0x3F);//8'b01xxxxxx, 8'b00111111);
		id_op = cmp(i, 0x80, 0x3F);//8'b10xxxxxx, 8'b00111111);
		id_opm = cmp(i, 0x86, 0x38);//8'b10xxx110, 8'b00111000);
		id_pop = cmp(i, 0xC1, 0x30);//8'b11xx0001, 8'b00110000);
		id_push = cmp(i, 0xC5, 0x30);//8'b11xx0101, 8'b00110000);
		id_rst = cmp(i, 0xC7, 0x38);//8'b11xxx111, 8'b00111000);
		id_xthl = cmp(i, 0xE3, 0x00);//8'b11100011, 8'b00000000);
		id_sphl = cmp(i, 0xF9, 0x00);//8'b11111001, 8'b00000000);
		id_pchl = cmp(i, 0xE9, 0x00);//8'b11101001, 8'b00000000);
		id_xchg = cmp(i, 0xEB, 0x00);//8'b11101011, 8'b00000000);
		id_cxx = cmp(i, 0xC4, 0x38);//8'b11xxx100, 8'b00111000);
		id_jxx = cmp(i, 0xC2, 0x38);//8'b11xxx010, 8'b00111000);
		id_rxx = cmp(i, 0xC0, 0x38);//8'b11xxx000, 8'b00111000);
		id_ret = cmp(i, 0xC9, 0x10);//8'b110x1001, 8'b00010000);
		id_call = cmp(i, 0xCD, 0x30);//8'b11xx1101, 8'b00110000);
		id_eidi = cmp(i, 0xF3, 0x08);//8'b1111x011, 8'b00001000);
		id_jmp = cmp(i, 0xC3, 0x08);//8'b1100x011, 8'b00001000);
		id_io = cmp(i, 0xD3, 0x08);//8'b1101x011, 8'b00001000);
		id_opi = cmp(i, 0xC6, 0x38);//8'b11xxx110, 8'b00111000);
		id_in = cmp(i, 0xDB, 0x00);//8'b11011011, 8'b00000000);
		id_popsw = cmp(i, 0xF1, 0x00);//8'b11110001, 8'b00000000);
		id_out = cmp(i, 0xD3, 0x00);//8'b11010011, 8'b00000000);
		id_11x = cmp(i, 0xC0, 0x3F);//8'b11xxxxxx, 8'b00111111);
		id_pupsw = cmp(i, 0xF5, 0x00);//8'b11110101, 8'b00000000);

		//		id_rxc = ~i[5] & i[3] & id_opa;
		id_rxc = ((~((i&(1<<5))!=0?1:0))&1) & ((i&1<<3)!=0?1:0) & id_opa;

		id_sha = ~gb(i,5) & id_opa;
		id_rlc = (((i>>3)&7) == 0?1:0) & id_opa;//(i[5:3] == 3'b000) & id_opa;
		id_rar = (((i>>3)&7) == 3?1:0) & id_opa;//(i[5:3] == 3'b011) & id_opa;
		id_daa = (((i>>3)&7) == 4?1:0) & id_opa;//(i[5:3] == 3'b100) & id_opa;
		id_cma = (((i>>3)&7) == 5?1:0) & id_opa;//(i[5:3] == 3'b101) & id_opa;
		id_stc = (((i>>3)&7) == 6?1:0) & id_opa;//(i[5:3] == 3'b110) & id_opa;
		id_cmc = (((i>>3)&7) == 7?1:0) & id_opa;//(i[5:3] == 3'b111) & id_opa;

		id_add = (((i>>3)&7) == 0?1:0) & (id_op | id_opi);//(i[5:3] == 3'b000) & (id_op | id_opi);
		id_adc = (((i>>3)&7) == 1?1:0) & (id_op | id_opi);//(i[5:3] == 3'b001) & (id_op | id_opi);
		id_sub = (((i>>3)&7) == 2?1:0) & (id_op | id_opi);//(i[5:3] == 3'b010) & (id_op | id_opi);
		id_sbb = (((i>>3)&7) == 3?1:0) & (id_op | id_opi);//(i[5:3] == 3'b011) & (id_op | id_opi);
		id_ana = (((i>>3)&7) == 4?1:0) & (id_op | id_opi);//(i[5:3] == 3'b100) & (id_op | id_opi);
		id_xra = (((i>>3)&7) == 5?1:0) & (id_op | id_opi);//(i[5:3] == 3'b101) & (id_op | id_opi);
		id_ora = (((i>>3)&7) == 6?1:0) & (id_op | id_opi);//(i[5:3] == 3'b110) & (id_op | id_opi);
		id_cmp = (((i>>3)&7) == 7?1:0) & (id_op | id_opi);//(i[5:3] == 3'b111) & (id_op | id_opi);

		 id80 = id_lxi || id_pop || id_opm || id_idm || id_dad
		 || id_xthl || id_xchg || id_jxx || id_ret || id_eidi
		 || id_nop || id_stlda || id_mvmr || id_mvrm || id_hlt
		 || id_opa || id_mvim || id_jmp || id_io || id_opi
		 || id_mvi || id_lsax || id_lhld || id_shld || id_op;
id81 = id_dcx || id_inx || id_sphl || id_pchl || id_xchg
|| id_eidi || id_nop || id_opa || id_op || id_mov
|| (id_idr && !id82);
id82 = id_pop || id_push || id_opm || id_idm || id_dad
|| id_rst || id_ret || id_rxx || id_mvrm || id_mvmr
|| id_hlt || id_mvim || id_io || id_opi || id_mvi
|| id_lsax;
id83 = id_opm || id_stlda || id_mvmr || id_mvrm || id_opi
|| id_mvi || id_lsax;
id84 = id_lxi || id_jxx || id_jmp;
id85 = id_push || id_idm || id_rst || id_xthl || id_cxx
|| id_call || id_mvim || id_shld || (id_io && !gb(i,3));
id86 = id_push || id_rst || id_xthl || id_cxx || id_call
|| id_mvmr || id_shld || (!gb(i,3) && (id_lsax || id_stlda));

id00 = id_xthl || id_pchl || id_sphl;
id01 = id_pop || id_rxx || id_ret;
id02 = id_mvi || id_opi || id_io;
id03 = id_rst || id_push || id_xthl || id_cxx || id_call;
id04 = id_rst || id_push || id_xthl || id_cxx || id_call;
id05 = id_rst || id_push || id_xthl || id_cxx || id_call || id_dcx;
id06 = id_pop || id_rxx || id_ret || id_dad || id_lhld || id_io;
id07 = id_dcx || id_inx || id_lxi || id_dad;
id08 = id_mov || id_mvi || id_idr || id_op;
id09 = id_rst || id_push || id_xthl || id_cxx || id_call || id_shld; 
id10 = id_pop || id_push || id_mvrm || id_mvi;

//______________________________________________________________________________
//
// function alu
// (
// input rxc,
// input ora,
// input ana,
// input xra,
// input x,
// input r,
// input nc,
// input rn,
// input cp
// );
// alu = x && r && cp && !(rxc || ora || ana || xra)
// || nc && (cp || x || r) && !(rxc || ora || ana || xra)
// || rxc && rn
// || ora && (x || r)
// || ana && (x && r)
// || xra && (x ^ r);
// }function
//
//
// s[0] = alu(id_rxc, id_ora, id_ana, id_xra, x[0], r[0], !c[0], r[1], cl) || (id_rlc && c[7]);
// s[1] = alu(id_rxc, id_ora, id_ana, id_xra, x[1], r[1], !c[1], r[2], c[0]);
// s[2] = alu(id_rxc, id_ora, id_ana, id_xra, x[2], r[2], !c[2], r[3], c[1]);
// s[3] = alu(id_rxc, id_ora, id_ana, id_xra, x[3], r[3], !c[3], r[4], c[2]);
// s[4] = alu(id_rxc, id_ora, id_ana, id_xra, x[4], r[4], !c[4], r[5], c[3]);
// s[5] = alu(id_rxc, id_ora, id_ana, id_xra, x[5], r[5], !c[5], r[6], c[4]);
// s[6] = alu(id_rxc, id_ora, id_ana, id_xra, x[6], r[6], !c[6], r[7], c[5]);
// s[7] = alu(id_rxc, id_ora, id_ana, id_xra, x[7], r[7], !c[7], ch, c[6]);
//
//
//______________________________________________________________________________
//
// arithmetic and logic unit
//
// alu_xwr = (f1 && m1 && t3) || (f2 && (a327 || t4f1 && (id_out || !id_11x)));
//
alu_xwr = (a327 || t4f1 && (id_rst || id_out || !id_11x));
alu_xout = !(id_sub || id_sbb || id_cmp || id_cma);
alu_xrd = t1698 || a358;
x = alu_xout ? xr : !xr;

alu_ald = t2222 && ( id_adc || id_add || id_daa || id_xra || id_sbb
					|| id_sub || id_ana || id_ora || id_sha || id_cma);
alu_ard = t1375 || a398;
alu_awr = t1497 || a357;

alu_r00 = id_dcr && t4f1;
alu_srd = t1668;
alu_rwr = t1780;
alu_rld = t4f1 && (id_sha || id_op || id_opi);

daa = id_daa && t4f1;
		daa_x6 = (gb(acc,3) && (gb(acc,2) || gb(acc,1))) || psw_ac;
		daa_6x = ((gb(acc,3) && (gb(acc,2) || gb(acc,1))) && gb(acc,4) && gb(acc,7))
			|| (gb(acc,7) && (gb(acc,6) || gb(acc,5))) || tmp_c;

		s = ((id_rlc && gb(c,7))&&1)
			|| ((id_rxc || id_ora || id_ana || id_xra) ? 0 : (x + r + cl))
			|| (id_rxc ? ((ch<<7)||(r>>1)) : 0)
			|| (id_ora ? (x || r) : 0)
			|| (id_ana ? (x && r) : 0)
			|| (id_xra ? (x ^ r) : 0);

		cl = tmp_c && ~id_daa && ~id_rlc && ~id_ora && ~id_xra && ~id_rxc;
		ch = tmp_c && id_rar || gb(r,0) && ~id_rar;

//
// BOOL ca0_n, ca2_n, ca1, ca3;
// ca0_n = !(cl && (x[0] || r[0])) && !(x[0] && r[0]) && !(id_ana && id_rxc);
// ca2_n = !(ca1 && (x[2] || r[2])) && !(x[2] && r[2]) && !(id_ana && id_rxc);
// ca1 = !(!x[1] && !r[1]) && !(ca0_n && (!x[1] || !r[1])) && !(id_ora || id_rxc || id_xra);
// ca3 = !(!x[3] && !r[3]) && !(ca2_n && (!x[3] || !r[3])) && !(id_ora || id_rxc || id_xra);
//
/*c[0] = (r[0] && x[0]) || (cl && (r[0] || x[0])); 
c[1] = (r[1] && x[1]) || (c[0] && (r[1] || x[1])); 
c[2] = (r[2] && x[2]) || (c[1] && (r[2] || x[2])); 
c[3] = (r[3] && x[3]) || (c[2] && (r[3] || x[3])); 
c[4] = (r[4] && x[4]) || (c[3] && (r[4] || x[4])); 
c[5] = (r[5] && x[5]) || (c[4] && (r[5] || x[5])); 
c[6] = (r[6] && x[6]) || (c[5] && (r[6] || x[6])); 
c[7] = (r[7] && x[7]) || (c[6] && (r[7] || x[7])); */
		c = (r & x) | (((c<<1)&cl) & (r | x));

alu_frd = t2046; /* || t4f1 && (id_11x && !id_out); */
alu_zrd = m1f1 && t3f1;

a398 = t1993 && ((t1994 && id08) || id_opa || id_stlda || id_lsax || id_io);

if(posedgeclk)
{
	if (f1) 
	{
		t1375 = t2 && m4 && id_pupsw;
		t1497 = t3 && m5 && id_popsw;
		t1698 = t5 && m1 && !id_inr && !id_dcr
			|| t3 && m5 && id_rst;
		t1668 = t2 && m5 && (id_inr || id_dcr)
			|| t3 && m5 && id_dad
			|| t3 && m4 && id_dad 
			|| t5 && m1 && (id_inr || id_dcr);
		t1780 = t3 && m1
			|| t1 && (m4 || m5) && id_dad;
		t2222 = (t2 && m1) || (t1 && m5);
		a327 = t3 && m4 && !(id_dad || id_out || id_rst)
			|| t2 && (m4 || m5) && id_dad;
		a357 = t3 && m5 && (id_io || id_mvim) && sy_wo_n
			|| t3 && m4 && (id_stlda || id_lsax || id_mvmr) && sy_wo_n
			|| acc_sel && id08 && (t5 && m1 || t3 && m4);
		a358 = t2 && !sy_wo_n && (id_io || id_mvim || id_stlda || id_lsax || id_mvmr);

		psw_ld = t3 && m4 && id_popsw;
		psw_wr = t2 && m1 && (id_opi || id_inr || id_dcr || id_daa || id_op);
		t2046 = t2 && m5 && id_pupsw; /* || reset || t3 && m1; */
		// 
		// t2047 = reset
		// || t3 && m1
		// || t3 && m5 && id_rst;
		//
		t1993 = t4 && m1;
		t1994 = acc_sel;
		t2133 = !id_rxc && gb(c,7);
		t2175 = t3 && m1
			|| t2 && m5 && id_dad;
	}
}

if(posedgeclk)
{
	if (f2)
	{
		if (alu_xwr) xr = id_rst ? (i & 0x38):d;//8'b00111000) : d;
			if (alu_awr) acc = d;
		if (alu_ald) acc = s;
		if (alu_rld) r = acc;
		if (alu_rwr) r = d;
		if (alu_r00) r = 0xFF;//8'hff;
			if (daa)
			{
				daa_x6?r|=6:r&=~6;
				daa_6x?r|=0x60:r&=~0x60;
			}
			if (psw_ld)
			{
				psw_c  = gb(d,0); // x gbLister was in original Intel design
				psw_p  = gb(d,2);
				psw_ac = gb(d,4);
				psw_z  = gb(d,6);
				psw_s  = gb(d,7);
			}
			if (psw_wr)
			{
/*				psw_p = ~(^s);
				psw_ac = (c[3] && !id_xra && !id_ora && !id_rxc) || (id_ana && (x[3] || r[3]));
				psw_z = !(||s);
				psw_s = s[7];*/
					uint8_t t = 0;
					for(int p = 0; p<8; p++)
					{
						t += gb(s,p);
					}
					psw_p  = (t&1)!=0?0:1;//~(^s);
					psw_ac = (gb(c,3) && !id_xra && !id_ora && !id_rxc) || (id_ana && (gb(x,3) || gb(r,3)));
					psw_z  = s==0?1:0;//~(|s);
					psw_s  = gb(s,7);
			}
			if (t2222)
			{
				if (id_xra || id_stc || id_ora || id_ana || id_cmc)
					psw_c = !tmp_c;
				if (id_cmp || id_sbb || id_sub)
					psw_c = !(t2133 || id_rxc && gb(x,0));
				if (id_dad || id_sha || id_adc || id_add)
					psw_c = t2133 || id_rxc && gb(x,0);
			}
			if (daa && daa_6x) 
				psw_c = 1;

			if (t2175) 
				tmp_c = psw_c;
			if (t4f1)
			{
				if (id_sbb) 
					tmp_c = !psw_c;
				if (id_inr || id_ora || id_xra || id_ana || id_cmp || id_sub)
					tmp_c = 1;
				if (id_dad || id_cma || id_dcr || id_add || id_stc)
					tmp_c = 0;
			}
	}
}

//______________________________________________________________________________
//
}
BOOL CVM80A::cmp(uint8_t i, uint8_t c, uint8_t m)
{
	uint8_t res = (~(i ^ c) | m)==0xFF?TRUE:FALSE;
	return res;
}

