#pragma once
#include "stdafx.h" // -      
#include "vsm.hpp"
class i8224 : public IDSIMMODEL
{
public:
	INT isdigital (CHAR *pinname);
	VOID setup (IINSTANCE *inst, IDSIMCKT *dsim);
	VOID runctrl (RUNMODES mode);
	VOID actuate (REALTIME time, ACTIVESTATE newstate);
	BOOL indicate (REALTIME time, ACTIVEDATA *data);
	VOID simulate (ABSTIME time, DSIMMODES mode);
	VOID callback (ABSTIME time, EVENTID eventid);
private:
	IINSTANCE *inst;
	IDSIMCKT *ckt;
	IDSIMPIN *XTAL1;
	IDSIMPIN *XTAL2;
	IDSIMPIN *TANK;

	IDSIMPIN *SYNC;
	IDSIMPIN *RESIN;
	IDSIMPIN *RDYIN;

	IDSIMPIN *OSC;
	IDSIMPIN *C1;
	IDSIMPIN *C2;
	IDSIMPIN *C;

	IDSIMPIN *STB;
	IDSIMPIN *RES;
	IDSIMPIN *RDY;

	int count;
	DWORD FREQUENCY;
	long long t;
	bool osc, resetin, reset, ready, ststb, c1, c2;
	CFront FrontC2;
//	STATE  ;
	//Strob;
	//IDSIMPIN *Pin4;
};