//-----    Flipflop.cpp ------------------------------------
#include "stdafx.h" // -      
//---   .
#include "vsm.hpp" // -   VSM API  Labcenter Electronics.
#include "i8224.h" //-      .
//---------------------------------------------------------------------------
#define model_key 0x00000000 // -    Labcenter Electronics
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---   __declspec   dllexport   
//--- ,       dll.
//---------------------------------------------------------------------------
//---  IDSIMMODEL *createdsimmodel(...)    ,
//---      (batch mode operation).
//--- Proteus     ,   
//---   ,     (batch mode),  
//---    ,   .
//---
extern "C" IDSIMMODEL __declspec(dllexport) *createdsimmodel (CHAR *device, ILICENCESERVER *ils)
{
//---  :
//--- CHAR *device -     ,   
//---   .
//---     ,    
//--- DSIM      DLL,    
//---      ,    PRIMTIVE
//---   .
//--- ILICENCESERVER *ils -     (Licence Server).
//---       ,
//---   model_key  Labcenter Electronics,     .
//---   .
//---  :
//--- IDSIMMODEL * -      ,   
//---   IDSIMMODEL .
//---     createdsimmodel-----------------------------------
//--- MessageBox(0,"  !",
//--- "!",MB_ICONERROR);
if(ils->authorize(model_key))
{
//---     authorize(model_key) ---------------------------
//--- MessageBox(0,"  !",
//--- "!",MB_ICONERROR);
return new i8224; // -     FFDEVICE
}
else
{
//--- ,      --------------------------------
MessageBox(0,"   : [NULL]!",
"!",MB_ICONERROR);
return NULL;
}
}
//---------------------------------------------------------------------------
//---   PROSPICE,     .
//---     ,   ,  
//--- .
extern "C" VOID __declspec(dllexport) deletedsimmodel (IDSIMMODEL *model)
{
delete (i8224 *)model; // -   IDSIMMODEL ,   
// -   createdsimmodel.
}
//---------------------------------------------------------------------------
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fwdreason, LPVOID lpvReserved)
{
//--- if(fwdreason==DLL_PROCESS_ATTACH) //-    ..
//--- {
//--- MessageBox(0,"DLL    ",
//--- "!",MB_ICONERROR);
//--- }
return 1;
}
//---------------------------------------------------------------------------
/*  Win32      (Callback-function)
   ,    
(  ,  ).
 ,      DllEntryPoint.  DllEntryPoint  
  ;   DllMain.
   Win API LoadLibrary(),  DLL   .
    .
 ,       DllEntryPoint 
       .
    ,  ,    DllEntryPoint. 
    :
BOOL WINAPI DllEntryPoint(HINSTANCE hinstDLL,  
DWORD fdwReason,   
LPVOID lpvReserved);  
 fdwReason:DWORD  ,  ,  
   DllEntryPoint.
  DllEntryPoint   ; , fdwReason 
    :
DLL_PROCESS_ATTACH   DLL    
DLL_PROCESS_DETACH    DLL    
DLL_THREAD_ATTACH      ,  DLL
DLL_THREAD_DETACH ,      ,  
DLL, .*/
//---------------------------------------------------------------------------